# AutoMoDe-Harlequin

Integration of NEAT generated gens as modules for AutoMoDe

Based on AutoMoDe-private repository:

ARGoS3-AutoMoDe README
=====================

All useful information about the ARGoS3-AutoMoDe package, including installation and utilization instructions,
are regrouped in the following technical report [[[techrep]]]. Please cite this report if you use the ARGoS3-AutoMoDe package.

Package content
---------------

* bin :: This empty folder will contain the executable automode_main after compilation.
* experiments :: The folder where one should place experiment configuration files (.argos or .xml)
** chocolate :: The experiment configuration files of the experiments described in [[[chocolate]]]
** example :: The experiment configuration file used as example in the technical report of the package.
* loop-functions :: The folder where one should place loop functions classes.
** chocolate :: The loop functions files used in the experiments described in [[[chocolate]]]
** example :: The loop functions class used as example in the technical report of the package.
* optimization :: The folder where one should place files regarding the optimization algorithm used.
** example :: The necessary elements to launch irace on a small example described in the technical report.
*** execution-folder
*** experiments-folder
*** grammar_generator.sh
*** grammar.txt
*** scenario.txt
*** target-runner
* src :: The source files of ARGoS3-AutoMoDe package.
** cmake :: The .cmake files for ARGoS3.
** core :: The core classes of ARGoS3-AutoMoDe.
** modules :: The six behavior and six condition modules described in [[[chocolate]]]
** AutoMoDeMain.cpp :: The main procedure to launch ARGoS3-AutoMoDe with irace.


References
----------

[bibliography]

- [[[techrep]]]   A. Ligot, K. Hasselmann, B. Delhaisse, L. Garattoni, G. Francesca, M. Birattari.
  'AutoMoDe and NEAT implementations for the e-puck robot in ARGoS3'. Technical report TR/IRIDIA/2017-002.
  IRIDIA, UniversitĂ© libre de Bruxelles, Belgium.
- [[[chocolate]]] G. Francesca and M. Brambilla and A. Brutschy and L. Garattoni and R. Miletitch and G. Podevijn and A. Reina and T. Soleymani and M. Salvaro and C. Pinciroli and F. Mascia and V. Trianni and M. Birattari.
  'AutoMoDe-Chocolate: automatic design of control software for robot swarms'. Swarm Intelligence.
